! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
!+
! Module: newcolgen_mod
!
! Authors:  Ian Stewart - JBO
!          
! Description: Creates new columns in a FITS binary table.
! 
! Comments: 
! 
! $Id: module.f90,v 1.6 1998/05/27 13:45:39 gvacanti Exp $
!- 
module newcolgen_mod

  use dal
  use param  
  use errorHandling

  use dal_aux

  implicit none 

  private 

  ! Command-line parameters:

  public newcolgen

contains 

  !---------------------------------------------------------------------
  subroutine newcolgen
  !---------------------------------------------------------------------

    implicit none

    character(255) :: setTabName, setName, tabName
    integer(int16) :: numNewCols, newColNum

    type(DataSetT) :: set
    type(TableT) :: tab
    type(ColumnT) :: dataValCol
    integer(int32), pointer :: dataVals(:)
!    integer(int32) :: numSelRows
    character(255) :: colName
    integer(int32) :: colValue

    !-------------------------------------------------------------------
    ! Start

    setTabName = stringParameter('tab')
    numNewCols = parameterCount('newcolumnlist')
    if (numNewCols .ne. parameterCount('newcolvaluelist'))&
call error('columnListMismatch','')
  if (numNewCols <= 0) return

    call splitSetTabName(setTabName, setName, tabName) ! in ssclib/dal_aux.

    set = dataSet(setName, MODIFY)
    tab = table(set, tabName)

    do newColNum = 1, numNewCols
      colName = stringParameter('newcolumnlist', newColNum-1)
      colValue = intParameter('newcolvaluelist', newColNum-1)

!****** should change this interface to make it much more general. Make it similar to addattribute.

      dataValCol = addOrOpenColumn(tab, colName, INTEGER32)
      dataVals => int32Data(dataValCol)
      dataVals = colValue
      call release(dataValCol)
    end do

    call release(tab)
    call release(set)

  end subroutine newcolgen

  !---------------------------------------------------------------------
  subroutine template
  !---------------------------------------------------------------------

    implicit none

    !-------------------------------------------------------------------
    ! Start

  end subroutine template

end module newcolgen_mod
